﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using CommandBinding.Model;
using System.Windows;
using System.ComponentModel;
using C1.WPF.DataGrid;
using System.Windows.Controls;
using System.Windows.Media;

namespace CommandBinding.ViewModel
{
    public class EmployeeListView : INotifyPropertyChanged
    {
        private ICommand m_RowClickCommand;
        C1DataGrid c1DataGrid1;
        bool flag;
        public EmployeeListView(C1DataGrid c1DataGrid)
        {
            c1DataGrid1 = c1DataGrid;
            c1DataGrid1.PreviewKeyDown += c1DataGrid1_PreviewKeyDown;
            c1DataGrid1.PreviewKeyUp += c1DataGrid1_PreviewKeyUp;
            m_RowClickCommand = new DelegateCommand(TextBoxClick); //=>            
        }

        void c1DataGrid1_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.LeftCtrl || e.Key == Key.RightCtrl)
                flag = false;
        }

        void c1DataGrid1_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.LeftCtrl || e.Key == Key.RightCtrl)
                flag = true;
        }

        public void TextBoxClick(object parameter)
        {
            int index = ((C1.WPF.DataGrid.DataGridCellPresenter)(((System.Windows.Controls.Primitives.TextBoxBase)(parameter)).Parent)).Row.Index;
            if (!flag)
            {
                for (int i = 0; i < c1DataGrid1.Rows.Count - 1; i++)
                {
                    for (int j = 0; j < c1DataGrid1.Columns.Count; j++)
                    {
                        (c1DataGrid1[i, j].Presenter.Content as TextBox).Background = new SolidColorBrush(Colors.White);
                    }
                }
            }
            for (int j = 0; j < c1DataGrid1.Columns.Count; j++)
            {
                (c1DataGrid1[index, j].Presenter.Content as TextBox).Background = new SolidColorBrush(Colors.LightBlue);
                c1DataGrid1.CurrentRow = c1DataGrid1.Rows[index];
            }
        }

        public ICommand RowClickCommand
        {
            get
            {
                return m_RowClickCommand;
            }
        }

        public IList<Employee> EmployeeList
        {
            get
            {
                List<Employee> _list = new List<Employee>();
                _list.Add(new Employee() { FirstName = "John", LastName = "Wayne", Age = 35 });
                _list.Add(new Employee() { FirstName = "Maximus", LastName = "Decimus", Age = 33 });
                _list.Add(new Employee() { FirstName = "Alexander", LastName = "Conklin", Age = 42 });
                _list.Add(new Employee() { FirstName = "William", LastName = "Bourne", Age = 66 });
                _list.Add(new Employee() { FirstName = "Jacob", LastName = "Lee", Age = 26 });
                _list.Add(new Employee() { FirstName = "Mike", LastName = "Bourne", Age = 56 });
                _list.Add(new Employee() { FirstName = "Fuller", LastName = "Brown", Age = 36 });
                _list.Add(new Employee() { FirstName = "Miller", LastName = "Wayne", Age = 42 });
                _list.Add(new Employee() { FirstName = "Sam", LastName = "Conklin", Age = 21 });
                _list.Add(new Employee() { FirstName = "Mark", LastName = "Bourne", Age = 24 });
                return _list;
            }
        }

        public Employee GotFocusAction()
        {
            return new Employee();
        }

        public void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, e);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
